// THIS PLUGIN DROPS RANDOM OR EVERY "X" DEATHS A HEALTH PACKAGE AFTER A PLAYER DIES.
// RANDOM VALUE = 10 + PLAYERS ON SERVER! IF RANDOM = 9 A HEALTHPACK WILL BE DROPED.
//
// THE PLUGIN CONTAINS PARTS OF FEUERSTURMs DOD DROPHEALTHKIT SOURCE. (THANKS)
// 
// VERSION 1.4
// Converted from DOD:S to CS:GO
//
// VERSION 1.5
// added other Health Models, changed text
//
// VERSION 1.6
// added sound when pickup a HealthPack
//
// VERSION 1.7
// added max. Health where a player can pickup a healthpack
//
// VERSION 1.8
// added Cvar to control what happens when max HP is reached!
//
// VERSION 1.9
// added Sound when max HP reached
//

#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#define MAXENTITIES 1024
#define PLUGIN_VERSION "1.9"

public Plugin:myinfo = 
{
	name = "CS:GO Drop Random Healthpack Plugin",
	author = "Darkranger",
	description = "a dead player drops random a Healthpack!",
	version = PLUGIN_VERSION,
	url = "http://dark.asmodis.at"
}

static const String:g_HealthKit_Model[3][] = { "models/props/cs_italy/chianti02.mdl" , "models/chicken/chicken.mdl" , "models/props_urban/life_ring001.mdl" }
new Handle:HealthKitDropTimer[MAXENTITIES+1] = INVALID_HANDLE
new String:g_HealthKit_Sound[] = { "ui/beep22.wav" }  
new String:g_HealthKitdenied_Sound[] = { "player/suit_denydevice.wav" }
new g_HealthKit_Skin[2] = { 0, 0 }
new Handle:kithealth = INVALID_HANDLE
new Handle:kithealthmax = INVALID_HANDLE
new Handle:kithealthmaxvar = INVALID_HANDLE
new Handle:kittime = INVALID_HANDLE
new Handle:kitcount = INVALID_HANDLE
new Handle:dropmodel = INVALID_HANDLE
new kitcountcounter = 0
new deadkitammount = 0

public OnPluginStart()
{	
	CreateConVar("csgo_drop_random_health_version", PLUGIN_VERSION, "CS:GO Healthpackage drop Plugin Version", FCVAR_DONTRECORD|FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY)
	SetConVarString(FindConVar("csgo_drop_random_health_version"), PLUGIN_VERSION)
	kithealth = CreateConVar("csgo_drop_health_ammount", "40", "<#> = amount of HP to add to a player picking up a Healthpackage", FCVAR_PLUGIN, true, 25.0, true, 300.0)
	kithealthmax = CreateConVar("csgo_drop_health_maximum", "150", "max. Amount of Health a player can have to pickup a Healthpackage", FCVAR_PLUGIN, true, 100.0, true, 600.0)
	kithealthmaxvar = CreateConVar("csgo_drop_health_maximum_var", "0", "what happens when max. Health is reached: 0 = delete Healthpackage , 1 = Healthpackage will dropped from next dead player", FCVAR_PLUGIN, true, 0.0, true, 1.0)
	kittime = CreateConVar("csgo_drop_health_lifetime", "30", "<#> = number of seconds a dropped Healthpackage stays on the map", FCVAR_PLUGIN, true, 20.0, true, 180.0)
	kitcount = CreateConVar("csgo_drop_health_counter", "0", "drop a Package every X deaths! 0 = disable - when enabled random drop is disabled", FCVAR_PLUGIN, true, 0.0, true, 60.0)
	dropmodel = CreateConVar("csgo_drop_model", "3", "Model to use: 0=chianti bottle; 1=chicken; 2=Life Ring", FCVAR_PLUGIN, true, 0.0, true, 2.0)
	AutoExecConfig(true, "csgo_drop_random_health", "csgo_drop_random_health");
	HookEvent("player_death", OnPlayerDeath, EventHookMode_Pre)
}

public OnMapStart()
{
	PrecacheModel(g_HealthKit_Model[0],true)
	PrecacheModel(g_HealthKit_Model[1],true)
	PrecacheModel(g_HealthKit_Model[2],true)
	PrecacheSound(g_HealthKit_Sound, true)
	PrecacheSound(g_HealthKitdenied_Sound, true)
	kitcountcounter = 0
	deadkitammount = 0
}

public Action:OnPlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (GetConVarInt(kitcount) == 0)
	{
		if (deadkitammount == 1)
		{
			new client = GetClientOfUserId(GetEventInt(event, "userid"))
			new Float:deathorigin[3]
			GetClientAbsOrigin(client,deathorigin)
			deathorigin[2] += 5.0
			new healthkit = CreateEntityByName("prop_physics_override")
			SetEntityModel(healthkit,g_HealthKit_Model[GetConVarInt(dropmodel)])
			SetEntProp(healthkit, Prop_Send, "m_nSkin", g_HealthKit_Skin[0])
			DispatchSpawn(healthkit)
			TeleportEntity(healthkit, deathorigin, NULL_VECTOR, NULL_VECTOR)
			SDKHook(healthkit, SDKHook_Touch, OnHealthKitTouched)
			HealthKitDropTimer[healthkit] = CreateTimer(GetConVarFloat(kittime), RemoveDroppedHealthKit, healthkit, TIMER_FLAG_NO_MAPCHANGE)
			PrintToChatAll("PLAYER %N LOST A HEALTHPACK WITH %d !", client, GetConVarInt(kithealth))
			PrintCenterTextAll("PLAYER %N LOST A HEALTHPACK WITH %d !", client, GetConVarInt(kithealth))
			deadkitammount = 0
			return Plugin_Continue		
		}
		
		
		new randomplayercount = 12+GetClientCount()
		new randomdeath = GetURandomInt() % randomplayercount
		if (randomdeath == 9)
		{
			new client = GetClientOfUserId(GetEventInt(event, "userid"))
			new Float:deathorigin[3]
			GetClientAbsOrigin(client,deathorigin)
			deathorigin[2] += 5.0
			new healthkit = CreateEntityByName("prop_physics_override")
			SetEntityModel(healthkit,g_HealthKit_Model[GetConVarInt(dropmodel)])
			SetEntProp(healthkit, Prop_Send, "m_nSkin", g_HealthKit_Skin[0])
			DispatchSpawn(healthkit)
			TeleportEntity(healthkit, deathorigin, NULL_VECTOR, NULL_VECTOR)
			SDKHook(healthkit, SDKHook_Touch, OnHealthKitTouched)
			HealthKitDropTimer[healthkit] = CreateTimer(GetConVarFloat(kittime), RemoveDroppedHealthKit, healthkit, TIMER_FLAG_NO_MAPCHANGE)
			PrintToChatAll("PLAYER \x04 %N \x01 LOST A HEALTHPACK WITH %d !", client, GetConVarInt(kithealth))
			PrintCenterTextAll("PLAYER %N LOST A HEALTHPACK WITH %d !", client, GetConVarInt(kithealth))
			return Plugin_Continue
		}
	}
	kitcountcounter++
	if (GetConVarInt(kitcount) == kitcountcounter)
	{
		new client = GetClientOfUserId(GetEventInt(event, "userid"))
		new Float:deathorigin[3]
		GetClientAbsOrigin(client,deathorigin)
		deathorigin[2] += 5.0
		new healthkit = CreateEntityByName("prop_physics_override")
		SetEntityModel(healthkit,g_HealthKit_Model[GetConVarInt(dropmodel)])
		SetEntProp(healthkit, Prop_Send, "m_nSkin", g_HealthKit_Skin[0])
		DispatchSpawn(healthkit)
		TeleportEntity(healthkit, deathorigin, NULL_VECTOR, NULL_VECTOR)
		SDKHook(healthkit, SDKHook_Touch, OnHealthKitTouched)
		HealthKitDropTimer[healthkit] = CreateTimer(GetConVarFloat(kittime), RemoveDroppedHealthKit, healthkit, TIMER_FLAG_NO_MAPCHANGE)
		PrintToChatAll("PLAYER \x04 %N \x01 LOST A HEALTH PACKAGE WITH %d !", client, GetConVarInt(kithealth))
		PrintCenterTextAll("PLAYER %N LOST A HEALTH PACKAGE WITH %d !", client, GetConVarInt(kithealth))
		kitcountcounter = 0
		return Plugin_Continue
	}
	return Plugin_Continue
}

public Action:OnHealthKitTouched(healthkit, client)
{
	if(client > 0 && client <= GetMaxClients() && healthkit > 0 && !IsFakeClient(client) && IsValidEntity(client) && IsClientInGame(client) && IsPlayerAlive(client) && IsValidEdict(healthkit))
	{
		new health = GetClientHealth(client)
		new healthkitadd = GetConVarInt(kithealth)
		new healthkitmax = GetConVarInt(kithealthmax)
		if (health <= healthkitmax)
		{
			SetEntityHealth(client, health + healthkitadd)
			KillHealthKitTimer(healthkit)
			PlayPickUpSound(client)
			RemoveEdict(healthkit)
			PrintToChat(client, " \x04 YOU PICKED UP HEALTHKIT WITH %d !", GetConVarInt(kithealth))
			PrintCenterText(client, "YOU PICKED UP HEALTHKIT WITH %d !", GetConVarInt(kithealth))
		}
		else
		{
			if (GetConVarInt(kithealthmaxvar) == 0)
			{
				KillHealthKitTimer(healthkit)
				RemoveEdict(healthkit)
				PlayDeniedSound(client)
				PrintToChat(client, " \x04 YOU HAVE TOO MUCH HEALTH - HEALTHKIT DESTROYED!!")
				PrintCenterText(client, "YOU HAVE TOO MUCH HEALTH - HEALTHKIT DESTROYED!!")
			}
			if (GetConVarInt(kithealthmaxvar) == 1)
			{
				KillHealthKitTimer(healthkit)
				RemoveEdict(healthkit)
				PlayDeniedSound(client)
				PrintToChat(client, " \x04 TOO MUCH HEALTH! - THE NEXT DEAD PLAYER DROPS A NEW ONE!")
				PrintCenterText(client, "TOO MUCH HEALTH! - THE NEXT DEAD PLAYER DROPS A NEW ONE!")
				deadkitammount = 1
			}	
		}	
	}
	return Plugin_Handled
}

stock KillHealthKitTimer(healthkit)
{
	if(HealthKitDropTimer[healthkit] != INVALID_HANDLE)
	{
		CloseHandle(HealthKitDropTimer[healthkit])
	}
	HealthKitDropTimer[healthkit] = INVALID_HANDLE
}

stock PlayPickUpSound(client)
{
	EmitSoundToClient(client, g_HealthKit_Sound, SOUND_FROM_PLAYER,SNDCHAN_WEAPON,SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL)
}

stock PlayDeniedSound(client)
{
	EmitSoundToClient(client, g_HealthKitdenied_Sound, SOUND_FROM_PLAYER,SNDCHAN_WEAPON,SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL)
}

public Action:RemoveDroppedHealthKit(Handle:timer, any:healthkit)
{
	HealthKitDropTimer[healthkit] = INVALID_HANDLE
	if(IsValidEdict(healthkit))
	{
		RemoveEdict(healthkit)
	}
	return Plugin_Handled
}